/* prof. Constantin Galatan
 */

#include <fstream>
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <iomanip>
using namespace std;

ifstream fin("miting.in");
ofstream fout("miting.out");

const int MaxN = 61, MaxC = 11, MaxV = 3601, Inf = (1 << 13),
		di[] = { -1, 0, 1, 0}, dj[] = { 0, 1, 0, -1};
using Matr = short[MaxC][MaxC][MaxV];
using PII  = pair<short, short>;

Matr c;
int N, M, n, nc, z[MaxN][MaxN];  // Nr[i][j] = numarul de ordine corespunzator celulei(i, j)
vector<string> H;
string cuv;
deque<PII> D;

bool Ok(int i, int j);

int main()
{
	int imin = MaxN, jmin = MaxN, imax = -1, jmax = -1, P;

	fin >> P >> N >> M >> cuv;
	H = vector<string>(N, string(M, ' '));
	for (int i = 0; i < N; ++i)
		for (int j = 0; j < M; ++j)
		{
			char c;	fin >> c;
			if ( isupper(c) )
            {
                imin = min(imin, i); jmin = min(jmin, j);
				imax = max(imax, i); jmax = max(jmax, j);
				D.push_front({i, j});
            }
			else
				if ( c != '#')
					D.push_back({i, j});
			H[i][j] = c;
		}

	fin.close();
    if ( P == 1 )
	{
		fout << (imax - imin + 1) * (jmax - jmin + 1) << '\n';
		fout.close();
		exit(0);
	}
	nc = cuv.size();


	vector<int> pos('Z' + 1);  // pozitiile caracterelor in cuvant
	for ( int i = 0; i < nc; ++i)
		pos[cuv[i]] = i;

	// Dupa sortare primele nc celule vor contine literele i ordinea din cuvant
	sort(D.begin(), D.begin() + nc,
			[&pos](const PII& p1, const PII& p2)
			{ return pos[H[p1.first][p1.second]] < pos[H[p2.first][p2.second]]; }
		);

	n = D.size();

	for (int k = 0; k < n; ++k)
	{
		int i = D[k].first, j = D[k].second;
		z[i][j] = k;
	}

	for (int i = 0; i < nc; ++i)
	{
		for (int u = 0; u < n; ++u)
			for (int j = 0; j < nc; ++j)
				c[i][j][u] = Inf;

		c[i][i][i] = 0;
	}

	for ( int l = 1; l <= nc; ++l)
		for (int i = 0; i < nc - l + 1; ++i)
		{
			short j = i + l - 1, old;
			queue<int> Q;
			for (int x = 0; x < n; ++x)
			{
				if (l >= 2)
				{
                    old = c[i][j][x];
					for (int k = i; k < j; ++k)
						c[i][j][x] = min(c[i][j][x], short(c[i][k][x] + c[k + 1][j][x]));
				}

				if ( c[i][j][x] < old || c[i][j][x] == 0)
						Q.push(x);
			}
            if ( l == nc ) break;
			int I, J, iv, jv, x, y;
			while ( !Q.empty() )
			{
				x = Q.front();	Q.pop();
				I = D[x].first;
				J = D[x].second;

				for (int d = 0; d < 4; ++d )
				{
					iv = I + di[d];
					jv = J + dj[d];
					y = z[iv][jv];
					if ( Ok(iv, jv) && c[i][j][y] > c[i][j][x] + 1)
					{
						c[i][j][y] = c[i][j][x] + 1;
						Q.push(y);
					}
				}
			}
		}

    short res = Inf;
	for (short x = 0; x < n; ++x)
		res = min(res, c[0][nc - 1][x]);

	if ( res != Inf )
        fout << res << '\n';
    else
        fout << -1 << '\n';

	fout.close();
}

inline bool Ok(int i, int j)
{
	if ( i < 0 || j < 0 || i >= N || j >= M ) return false;
	if ( H[i][j] == '#') return false;
	return true;
}

