//Em. Cerchez 100 puncte
#include <stdio.h>
#include <assert.h>
#define VMAX 50000
#define NMAX 10000
#define NRMAXPRIME 50000


int n, nrprim, nrf, cerinta;
char ciur[VMAX];
int prim[NRMAXPRIME];
int fp[NRMAXPRIME];
int mf[NRMAXPRIME];
int p[NMAX];
long long int cant;

void eratostene();
void afisare();
void determina(int d, int *p, int *c);
int cmmdc();
int euclid(int a, int b);
int putere(int x, int y);

int main()
{int i, d, c, cate;
 FILE *fin=fopen("arma.in","r");
 eratostene();
 cate=fscanf(fin,"%d%d",&cerinta, &n);
 assert(cate==2);
 assert(0<n && n<=10000);
 for (i=0; i<n; i++)
      {
       cate=fscanf(fin,"%d", &d);
       assert(cate==1);
       assert(d>0 && d<=2000000000);
       determina(d,&p[i],&c);
       cant+=c;
      }
 afisare();
 return 0;
}

void eratostene()
{int d, j;
 for (d=2; d*d<VMAX; d++)
      if (!ciur[d])
          for (j=d*d; j<VMAX; j+=d)
              ciur[j]=1;
 //transfer intr-un vector numerele prime <=vmax
 prim[0]=2; nrprim=1;
 for (d=3; d<VMAX; d+=2)
      if (!ciur[d]) prim[nrprim++]=d;
}

void determina(int d, int *pp, int *cc)
{int m, j, p, c;
 nrf=0;
 for (j=0; j<nrprim && prim[j]*prim[j]<=d; j++)
     {
      for (m=0; d%prim[j]==0; m++,d/=prim[j]);
	  if (m)
         {
          fp[nrf]=prim[j];
          mf[nrf++]=m;
          }
      }
 if (d>1)
    {
     fp[nrf]=d;
     mf[nrf++]=1;
    }
 p=cmmdc();
 c=1;
 for (j=0; j<nrf; j++)
      c*=putere(fp[j],mf[j]/p);
*pp=p; *cc=c;
}

void afisare()
{int i;
 FILE * fout=fopen("arma.out","w");
 if (cerinta==1)
    fprintf(fout,"%lld\n", cant);
    else
    for (i=0; i<n; i++) fprintf(fout,"%d\n",p[i]);
 fclose(fout);
}

int cmmdc()
{int d=mf[0], i;
 for (i=1; i<nrf; i++)
      d=euclid(d,mf[i]);
 return d;
}

int euclid(int a, int b)
{int r;
 while (b)
   {
       r=a%b; a=b; b=r;
   }
 return a;
}

int putere(int x, int y)
{int p;
 if (y==0) return 1;
 p=putere(x,y/2);
 if (y%2) return x*p*p;
 return p*p;
}
